"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
exports.default = (aspectRatio) => {
    const [el, setEl] = (0, react_1.useState)(null);
    (0, react_1.useLayoutEffect)(() => {
        if (!el)
            return;
        const cb = () => {
            const { width } = el.getBoundingClientRect();
            const height = width / aspectRatio;
            el.style.height = height + "px";
        };
        cb();
        window.addEventListener("resize", cb);
        return () => {
            window.removeEventListener("resize", cb);
        };
    }, [el]);
    return setEl;
};
