"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
exports.default = (onClick) => {
    const [el, setEl] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        if (!el)
            return;
        let mouseDownX = 0;
        let mouseDownY = 0;
        let mouseDownTime = 0;
        const handleMouseDown = (e) => {
            mouseDownX = e.clientX;
            mouseDownY = e.clientY;
            mouseDownTime = Date.now();
        };
        el.addEventListener("mousedown", handleMouseDown);
        const handleClick = (e) => {
            const xDiff = Math.abs(e.clientX - mouseDownX);
            const yDiff = Math.abs(e.clientY - mouseDownY);
            const timeDiff = Date.now() - mouseDownTime;
            if (xDiff > 10 || yDiff > 10 || timeDiff > 250) {
                e.preventDefault();
                e.stopPropagation();
                return;
            }
            onClick(e);
        };
        el.addEventListener("click", handleClick);
        return () => {
            el.removeEventListener("mousedown", handleMouseDown);
            el.removeEventListener("click", handleClick);
        };
    }, [el]);
    return setEl;
};
