"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const resize_observer_polyfill_1 = require("resize-observer-polyfill");
const zeroBounds = new DOMRect();
exports.default = (cb) => {
    const [el, setEl] = (0, react_1.useState)(null);
    const [size, setSize] = (0, react_1.useState)([0, 0, zeroBounds]);
    (0, react_1.useLayoutEffect)(() => {
        if (!el)
            return;
        const resizeObserver = new resize_observer_polyfill_1.default(() => {
            const size = [el.clientWidth, el.clientHeight, el.getBoundingClientRect()];
            cb === null || cb === void 0 ? void 0 : cb(size);
            setSize(size);
        });
        resizeObserver.observe(el);
        return () => {
            resizeObserver.disconnect();
        };
    }, [el]);
    return [setEl, size, el];
};
