import { useLayoutEffect, useState } from "react";
import ResizeObserver from "resize-observer-polyfill";
const zeroBounds = new DOMRect();
export default (cb) => {
    const [el, setEl] = useState(null);
    const [size, setSize] = useState([0, 0, zeroBounds]);
    useLayoutEffect(() => {
        if (!el)
            return;
        const resizeObserver = new ResizeObserver(() => {
            const size = [el.clientWidth, el.clientHeight, el.getBoundingClientRect()];
            cb === null || cb === void 0 ? void 0 : cb(size);
            setSize(size);
        });
        resizeObserver.observe(el);
        return () => {
            resizeObserver.disconnect();
        };
    }, [el]);
    return [setEl, size, el];
};
