import { useState, useEffect } from "react"

export default <T>(value: T, delay: number) => {
	const [val, setVal] = useState(value)

	useEffect(() => {
        const timeout = setTimeout(() => setVal(value), delay)

        return () => {
            clearTimeout(timeout)
        }
    }, [value])

	return val
}